*( CHARTS.CMD--Create a bar chart report in 132-column format.)
*( ------ Declare and Initialize Variables ------ )
SET VAR gtitle1 TEXT=.%1, gtitle2 TEXT=.%2, gtitle3 TEXT=.%3
SET VAR dtype TEXT=.%4  *( Data type.)
SET VAR pg INTEGER  *( Page count.)
SET VAR lncnt INTEGER  *( Line count.)
SET VAR ltoggle INTEGER  *( Switch shows if line is shaded.)
SET VAR gmod REAL  *( work variable for MOD function results.)
*( LN1, LN2, and LN3 hold headers & VSCALE holds the scale.)
SET VAR ln1 TEXT, ln2 TEXT, ln3 TEXT, vscale TEXT
SET VAR v179 TEXT=(CHAR(179))  *( Single veritcal line.)
SET VAR v223 TEXT=(CHAR(223))  *( 1/2 square--upper.)
SET VAR v220 TEXT=(CHAR(220))  *( 1/2 square--lower.)
SET VAR v176 TEXT=(CHAR(176))  *( Shadow for bar.)
SET VAR v255 TEXT=(CHAR(255))  *( Hard space.)
SET VAR v196 TEXT=(CHAR(196))  *( Single horizontal line.)
SET VAR v194 TEXT=(CHAR(194))  *( Upper T character.)
SET VAR v216 TEXT=(CHAR(216))  *( Double horizontal/cross.)
SET VAR v205 TEXT=(CHAR(205))  *( Double horizontal.)
SET VAR v219 TEXT=(CHAR(219))  *( Full block character.)
SET VAR v221 TEXT=(CHAR(221))  *( Left 1/2 block character.)
SET VAR v193 TEXT=(CHAR(193))  *( Lower T character.)
SET VAR gmax &dtype, gvalue &dtype
SET MESSAGES OFF
SWITCH .dtype
  CASE 'CURRENCY' ; SET VAR gcol='g_curr' ; BREAK
  CASE 'REAL' ; SET VAR gcol='g_real' ; BREAK
  CASE 'INTEGER' ; SET VAR gcol='g_integer' ; BREAK
  CASE 'DOUBLE' ; SET VAR gcol='g_double' ; BREAK
  DEFAULT
    CLS FROM 23 TO 25
    BEEP
    WRITE 'The fourth parameter is invalid data type' +
      AT 21, 10 WHITE ON RED
    WRITE 'It must be CURRENCY, INTEGER, REAL' +
      AT 22, 10 WHITE ON RED
    WRITE 'or DOUBLE.' AT 23, 10 WHITE ON RED
    WRITE 'Press any key to continue...' AT 24, 15 YELLOW
    PAUSE
    RETURN
ENDSW
SET VAR ltoggle=1, lncnt=88, pg=0
SET VAR ln1=(SFIL(.v223,130)), ln2=(SFIL(.v220,130))
WRITE .ln1  *( WRITE top border--title header.)
IF  gtitle1 <> 'off' THEN
  SET VAR gtitle1=(CTR(.gtitle1,130)) ; WRITE .gtitle1
ENDIF
IF  gtitle2 <> 'off' THEN
  SET VAR gtitle2=(CTR(.gtitle2,130))
  WRITE .gtitle2
ENDIF
IF  gtitle3 <> 'off' THEN
  SET VAR gtitle3=(CTR(.gtitle3,130))
  WRITE .gtitle3
ENDIF
WRITE .ln2  *( WRITE bottom border--title header.)
SET VAR glabel TEXT, gvalue &dtype, gmax &dtype
*( Get total and maximum to plot percentage and scale it.)
SELECT SUM(&gcol), MAX(&gcol) +
  INTO gtot, gmax FROM graphs
SET VAR itmp INTEGER=((.gmax / .gtot) * 100)  *( scale it.)
SET VAR itmp=(.itmp / 5), itmp=(.itmp + 1), itmp=(.itmp * 5)
IF  itmp < 10 THEN ; SET VAR itmp=10 ; ENDIF
IF  itmp > 100 THEN ; SET VAR itmp=100 ; ENDIF
*( V1 is line segment one & V2 is line segment two.)
SET VAR v1=(SFIL(.v205,4) + .v216 + SFIL(.v205,4))
SET VAR v2=(SFIL(.v205,3) + .v216 + SFIL(.v205,4))
SET VAR vscale=('0' + .v1)
SWITCH .itmp  *( Determine the scale & set output string.)
  CASE 10 ; SET VAR vscale = +
    (.vscale+'2+.v1+'4'+.v1+'6'+.v1+'8'+.v1+'10'); BREAK
  CASE 15 ; SET VAR vscale = +
    (.vscale+'3'+.v1+'6'+.v1+'9'+.v2+'12'+.v2+'15'); BREAK
  CASE 20 ; SET VAR vscale = +
    (.vscale+'4'+.v1+'8'+.v2+'12'+.v2+'16'+.v2+'20'); BREAK
  CASE 25 ; SET VAR vscale = +
    (.vscale+'5'+.v1+'10'+.v2+'15'+.v2+'20'+.v2+'25'); BREAK
  CASE 30 ; SET VAR vscale = +
    (.vscale+'6'+.v1+'12'+.v2+'18'+.v2+'24'+.v2+'30'); BREAK
  CASE 35 ; SET VAR vscale = +
    (.vscale+'7'+.v1+'14'+.v2+'21'+.v2+'28'+.v2+'35'); BREAK
  CASE 40 ; SET VAR vscale = +
    (.vscale+'8'+.v1+'16'+.v2+'24'+.v2+'32'+.v2+'40'); BREAK
  CASE 45 ; SET VAR vscale = +
    (.vscale+'9'+.v1+'18'+.v2+'27'+.v2+'36'+.v2+'45'); BREAK
  CASE 50 ; SET VAR vscale = +
    (.vscale+'10'+.v2+'20'+.v2+'30'+.v2+'40'+.v2+'50'); BREAK
  CASE 55 ; SET VAR vscale = +
    (.vscale+'11'+.v2+'22'+.v2+'33'+.v2+'44'+.v2+'55'); BREAK
  CASE 60 ; SET VAR vscale = +
    (.vscale+'12'+.v2+'24'+.v2+'36'+.v2+'48'+.v2+'60'); BREAK
  CASE 65 ; SET VAR vscale = +
    (.vscale+'13'+.v2+'26'+.v2+'39'+.v2+'52'+.v2+'65'); BREAK
  CASE 70 ; SET VAR vscale = +
    (.vscale+'14'+.v2+'28'+.v2+'42'+.v2+'56'+.v2+'70'); BREAK
  CASE 75 ; SET VAR vscale  = +
    (.vscale+'15'+.v2+'30'+.v2+'45'+.v2+'60'+.v2+'75'); BREAK
  CASE 80 ; SET VAR vscale = +
    (.vscale+'16'+.v2+'32'+.v2+'48'+.v2+'64'+.v2+'80'); BREAK
  CASE 85 ; SET VAR vscale = +
    (.vscale+'17'+.v2+'34'+.v2+'51'+.v2+'68'+.v2+'85'); BREAK
  CASE 90 ; SET VAR vscale = +
    (.vscale+'18'+.v2+'36'+.v2+'54'+.v2+'72'+.v2+'90'); BREAK
  CASE 95
    SET VAR vscale = +
      (.vscale+'19'+.v2+'38'+.v2+'57'+.v2+'76'+.v2+'95')
    BREAK
  DEFAULT
    SET VAR vscale = +
      (.vscale+'20'+.v2+'40'+.v2+'60'+.v2+'80'+.v2+CHAR(209))
ENDSW
*( Start main processing loop.)
DECLARE p1 CURSOR FOR SELECT g_label, &gcol +
  FROM graphs ORDER BY g_label
OPEN p1
FETCH p1 INTO glabel, gvalue
WHILE SQLCODE <> 100 THEN
  *( ------ Write page header ------ )
  IF lncnt > 60 THEN
    IF pg > 0 THEN
      SET VAR ln1=(SFIL(.v196,128))
      SET VAR ln2=(CHAR(192) + .ln1 + CHAR(217))
      WRITE .ln2
      NEWPAGE
    ENDIF
    IF pg=0 THEN
      SET VAR lncnt=11
    ELSE
      SET VAR lncnt=9
    ENDIF
    SET VAR ln1=(SFIL(.v196,128))
    SET VAR ln2=(CHAR(218) + .ln1 + CHAR(191))
    WRITE .ln2
    SET VAR pg=(.pg + 1), ln3=(CTXT(.pg))
    SET VAR ln2=(.v179 & 'Date :' & CTXT(.#date) +
      & RJS('Page :',107) & RJS(.ln3,2) & .v179)
    WRITE .ln2
    SET VAR ln2=(CHAR(195) + .ln1 + CHAR(180))
    SET VAR ln2=(SPUT(.ln2,.v194,53))
    SET VAR ln2=(SPUT(.ln2,.v194,106))
    SET VAR ln2=(SPUT(.ln2,.v194,123))
    WRITE .ln2
    SET VAR ln2=(.v179 & LJS('Description',50) + .v179 +
      & CTR('GRAPH',50) & .v179 + RJS('Value',15) +
      & .v179 + 'Share' &  .v179)
    WRITE .ln2
    SET VAR ln1=(CHAR(205)), ln1=(SFIL(.ln1,128))
    SET VAR ln2=(CHAR(198) + .ln1 + CHAR(181))
    SET VAR ln2=(SPUT(.ln2,.v216,53))
    SET VAR ln2=(SPUT(.ln2,.v216,106))
    SET VAR ln2=(SPUT(.ln2,.v216,123))
    SET VAR ln2=(SPUT(.ln2,.vscale,54))
    WRITE .ln2
  ENDIF
  *(  ------ Detail line processing ------ )
  IF  ltoggle=1 THEN
    SET VAR ltoggle=0, ln1=(SFIL(.v176,50))
  ELSE
    SET VAR ltoggle=1, ln1=(SFIL(.v255,50))
  ENDIF
  SET VAR greal REAL=((((.gvalue / .gtot) * 100) / .itmp) * 50)
  SET VAR gmod=(MOD(.greal,1)), greal INTEGER
  IF gmod >= 0.5 THEN
    SET VAR greal=(.greal + 1)
  ENDIF
  SET VAR ln2=(SFIL(.v219,.greal))
  SET VAR greal REAL=((.gvalue / .gtot) * 100)
  SET VAR ln3=(CTXT(.greal))
  IF greal < 10.0 THEN
    SET VAR ln3=(SGET(.ln3,4,1))
  ELSE
    SET VAR ln3=(SGET(.ln3,5,1))
  ENDIF
  SET VAR ln2=(SPUT(.ln1,.ln2,1)), ln1=(CTXT(.gvalue))
  SET VAR ln2=(.v179 & LJS(.glabel,50) + .v179 + 
    + CHAR(175) + .ln2 + CHAR(174) + .v179 + 
    + RJS(.ln1,15) & .v179 + RJS(.ln3,5) + '%' + .v179)
  WRITE .ln2
  SET VAR lncnt=(.lncnt + 1)
  FETCH p1 INTO glabel, gvalue
ENDWHILE
DROP CURSOR p1
SET VAR ln1=(SFIL(.v196,128))
SET VAR ln2=(CHAR(195) + .ln1 + CHAR(180))
SET VAR ln2=(SPUT(.ln2,.v193,53))
SET VAR ln2=(SPUT(.ln2,.v193,106))
SET VAR glabel=(CHAR(197))
SET VAR ln2=(SPUT(.ln2,.glabel,123))
WRITE .ln2
SET VAR ln3=(CTXT(.gtot))
SET VAR ln2=(.v179 + RJS(.ln3,120) & .v179 + RJS(.v179,7))
WRITE .ln2
SET VAR ln2=(CHAR(192) + .ln1 + CHAR(217))
SET VAR ln2=(SPUT(.ln2,.v193,123))
WRITE .ln2
NEWPAGE
SET MANY=*
CLEAR VAR %1, %2, %3, %4, gtitle1, gtitle2, gititle3, dtype, +
  pg, lncnt, ltoggle, gmod, ln1, ln2, ln3, vscale, glabel, itmp, +
  gvalue, gmax, v179, v223, v220, v176, v255, v196, v194, +
  v216, v219, v221, v193
SET MANY=%

